# This is a BitKeeper generated diff -Nru style patch.
#
# ChangeSet
#   2005/03/18 16:43:54-05:00 len.brown@intel.com 
#   [ACPI] S3 Suspend to RAM: fix driver suspend/resume methods
#   
#   Drivers should do this:
#   
#   .suspend()
#   	pci_disable_device()
#   
#   .resume()
#   	pci_enable_device()
#   
#   http://bugzilla.kernel.org/show_bug.cgi?id=3469
#   
#   Signed-off-by: David Shaohua Li <shaohua.li@intel.com>
#   Signed-off-by: Len Brown <len.brown@intel.com>
# 
# drivers/usb/core/hcd-pci.c
#   2005/03/18 16:41:51-05:00 len.brown@intel.com +1 -0
#   .suspend/.resume: pci_disable_device()/pci_enable_device()
# 
# drivers/pcmcia/yenta_socket.c
#   2005/03/03 00:34:31-05:00 len.brown@intel.com +3 -0
#   .suspend/.resume: pci_disable_device()/pci_enable_device()
# 
# drivers/net/ne2k-pci.c
#   2005/03/18 16:43:35-05:00 len.brown@intel.com +3 -0
#   .suspend/.resume: pci_disable_device()/pci_enable_device()
# 
# drivers/net/e1000/e1000_main.c
#   2005/03/03 00:33:08-05:00 len.brown@intel.com +1 -2
#   .suspend/.resume: pci_disable_device()/pci_enable_device()
# 
# drivers/net/b44.c
#   2005/03/03 00:33:59-05:00 len.brown@intel.com +3 -0
#   .suspend/.resume: pci_disable_device()/pci_enable_device()
# 
Index: linux-2.6.12/drivers/net/b44.c
===================================================================
--- linux-2.6.12.orig/drivers/net/b44.c	2005-07-09 23:35:04.000000000 -0400
+++ linux-2.6.12/drivers/net/b44.c	2005-07-09 23:54:00.000000000 -0400
@@ -1927,6 +1927,7 @@
 	b44_free_rings(bp);
 
 	spin_unlock_irq(&bp->lock);
+	pci_disable_device(pdev);
 	return 0;
 }
 
@@ -1936,6 +1937,8 @@
 	struct b44 *bp = netdev_priv(dev);
 
 	pci_restore_state(pdev);
+	pci_enable_device(pdev);
+	pci_set_master(pdev);
 
 	if (!netif_running(dev))
 		return 0;
Index: linux-2.6.12/drivers/net/ne2k-pci.c
===================================================================
--- linux-2.6.12.orig/drivers/net/ne2k-pci.c	2005-07-09 23:35:02.000000000 -0400
+++ linux-2.6.12/drivers/net/ne2k-pci.c	2005-07-09 23:54:00.000000000 -0400
@@ -660,6 +660,7 @@
 
 	netif_device_detach(dev);
 	pci_save_state(pdev);
+	pci_disable_device(pdev);
 	pci_set_power_state(pdev, pci_choose_state(pdev, state));
 
 	return 0;
@@ -671,6 +672,8 @@
 
 	pci_set_power_state(pdev, 0);
 	pci_restore_state(pdev);
+	pci_enable_device(pdev);
+	pci_set_master(pdev);
 	NS8390_init(dev, 1);
 	netif_device_attach(dev);
 
Index: linux-2.6.12/drivers/pcmcia/yenta_socket.c
===================================================================
--- linux-2.6.12.orig/drivers/pcmcia/yenta_socket.c	2005-07-09 23:35:08.000000000 -0400
+++ linux-2.6.12/drivers/pcmcia/yenta_socket.c	2005-07-09 23:54:00.000000000 -0400
@@ -1032,6 +1032,7 @@
 		pci_save_state(dev);
 		pci_read_config_dword(dev, 16*4, &socket->saved_state[0]);
 		pci_read_config_dword(dev, 17*4, &socket->saved_state[1]);
+		pci_disable_device(dev);
 
 		/*
 		 * Some laptops (IBM T22) do not like us putting the Cardbus
@@ -1055,6 +1056,8 @@
 		pci_restore_state(dev);
 		pci_write_config_dword(dev, 16*4, socket->saved_state[0]);
 		pci_write_config_dword(dev, 17*4, socket->saved_state[1]);
+		pci_enable_device(dev);
+		pci_set_master(dev);
 
 		if (socket->type && socket->type->restore_state)
 			socket->type->restore_state(socket);
Index: linux-2.6.12/drivers/usb/core/hcd-pci.c
===================================================================
--- linux-2.6.12.orig/drivers/usb/core/hcd-pci.c	2005-07-09 23:35:05.000000000 -0400
+++ linux-2.6.12/drivers/usb/core/hcd-pci.c	2005-07-09 23:54:00.000000000 -0400
@@ -380,6 +380,7 @@
 		usb_hc_died (hcd);
 	}
 
+	pci_enable_device(dev);
 	return retval;
 }
 EXPORT_SYMBOL (usb_hcd_pci_resume);
